summaryrefslogtreecommitdiffstats
path: root/academic/OpenFOAM
diff options
context:
space:
mode:
author Lorenzo Trevisan2017-09-23 15:20:17 +0200
committer David Spencer2017-09-23 15:20:17 +0200
commit416e9620f6d7752662260cd1d8dba40554cc74c6 (patch)
tree34421ab2aed33a42e8cdb50bf1abbd68964644df /academic/OpenFOAM
parenta7e0daa5ce8416faecb58f81e0d2955a3a1572ad (diff)
downloadslackbuilds-416e9620f6d7752662260cd1d8dba40554cc74c6.tar.gz
academic/OpenFOAM: Added (computational fluid dynamics).
Signed-off-by: David Spencer <idlemoor@slackbuilds.org>
Diffstat (limited to 'academic/OpenFOAM')
-rw-r--r--academic/OpenFOAM/OpenFOAM.SlackBuild99
-rw-r--r--academic/OpenFOAM/OpenFOAM.info12
-rw-r--r--academic/OpenFOAM/OpenFOAM.sh1
-rw-r--r--academic/OpenFOAM/README10
-rw-r--r--academic/OpenFOAM/slack-desc19
5 files changed, 141 insertions, 0 deletions
diff --git a/academic/OpenFOAM/OpenFOAM.SlackBuild b/academic/OpenFOAM/OpenFOAM.SlackBuild
new file mode 100644
index 0000000000..40f65f4173
--- /dev/null
+++ b/academic/OpenFOAM/OpenFOAM.SlackBuild
@@ -0,0 +1,99 @@
+#!/bin/sh
+
+# Slackware build script for OpenFOAM
+
+# Copyright 2017 Lorenzo Trevisan, Caorle, Venice, Italy
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+PRGNAM=OpenFOAM
+VERSION=${VERSION:-5.0}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+
+XVER=${VERSION%%.*}.x
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+CWD=$(pwd)
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $PKG
+mkdir -p opt/$PRGNAM
+cd $PKG/opt/$PRGNAM
+tar xvf $CWD/$PRGNAM-$XVER-version-$VERSION.tar.gz
+mv $PRGNAM-$XVER-version-$VERSION $PRGNAM-$VERSION
+tar xvf $CWD/ThirdParty-$XVER-version-$VERSION.tar.gz
+mv ThirdParty-$XVER-version-$VERSION ThirdParty-$VERSION
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+cd $PRGNAM-$VERSION
+
+sed -i -e '16s=-lreadline=-lreadline -lncurses=' ./applications/utilities/mesh/manipulation/setSet/Allwmake
+sed -i -e '47s=$HOME=/opt=' ./etc/bashrc
+
+# "Allwmake" below doesn't accept MAKEFLAGS. If MAKEFLAGS contains a -j option,
+# extract it and pass it to "Allwmake". (Thanks to Chris Willing)
+jval="$(echo $MAKEFLAGS |grep -o "\-j *[0-9]*" | grep -o "[0-9]*")" || true
+jobs=''
+[ -n "$jval" ] && jobs="-j${jval}"
+
+(
+ . ./etc/bashrc || true
+ cd $WM_PROJECT_DIR
+ ./Allwmake $jobs
+ # check for graphviz
+ if [ -x /usr/bin/dot ]; then
+ wmake all doc
+ fi
+)
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+install -D -m755 $CWD/OpenFOAM.sh $PKG/etc/profile.d/OpenFOAM.sh
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a \
+ $PKG/opt/$PRGNAM/$PRGNAM-$VERSION/doc/Guides/OpenFOAMUserGuide-A4.pdf \
+ $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.${PKGTYPE:-tgz}
diff --git a/academic/OpenFOAM/OpenFOAM.info b/academic/OpenFOAM/OpenFOAM.info
new file mode 100644
index 0000000000..dfdaffc707
--- /dev/null
+++ b/academic/OpenFOAM/OpenFOAM.info
@@ -0,0 +1,12 @@
+PRGNAM="OpenFOAM"
+VERSION="5.0"
+HOMEPAGE="https://openfoam.org/"
+DOWNLOAD="https://github.com/OpenFOAM/OpenFOAM-5.x/archive/version-5.0/OpenFOAM-5.x-version-5.0.tar.gz \
+ https://github.com/OpenFOAM/ThirdParty-5.x/archive/version-5.0/ThirdParty-5.x-version-5.0.tar.gz"
+MD5SUM="cd8c5bdd3ff39c34f61747c8e55f59d1 \
+ 76d619a8c79eae38baed2e08305eb923"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES="openmpi CGAL"
+MAINTAINER="Lorenzo Trevisan"
+EMAIL="lorenzo.trevisan@gmail.com"
diff --git a/academic/OpenFOAM/OpenFOAM.sh b/academic/OpenFOAM/OpenFOAM.sh
new file mode 100644
index 0000000000..ee304372f1
--- /dev/null
+++ b/academic/OpenFOAM/OpenFOAM.sh
@@ -0,0 +1 @@
+. /opt/OpenFOAM/OpenFOAM-5.0/etc/bashrc
diff --git a/academic/OpenFOAM/README b/academic/OpenFOAM/README
new file mode 100644
index 0000000000..b5a4298c1c
--- /dev/null
+++ b/academic/OpenFOAM/README
@@ -0,0 +1,10 @@
+OpenFOAM has an extensive range of features to simulate anything from
+turbulent flows in automotive aerodynamics, to fires and fire
+suppression in buildings, involving combustion, chemical reactions,
+heat transfer, liquid sprays and films. It includes tools for meshing
+in and around complex geometries (e.g. a vehicle), and for data
+processing and visualisation, and more. Almost all computations can be
+executed in parallel as standard to take full advantage of today’s
+multi-core processors and multi-processor computers.
+
+Optional dependency: graphviz (for documentation with graphs)
diff --git a/academic/OpenFOAM/slack-desc b/academic/OpenFOAM/slack-desc
new file mode 100644
index 0000000000..598081f06c
--- /dev/null
+++ b/academic/OpenFOAM/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+OpenFOAM: OpenFOAM (computational fluid dynamics)
+OpenFOAM:
+OpenFOAM: OpenFOAM has an extensive range of features to simulate anything from
+OpenFOAM: turbulent flows in automotive aerodynamics, to fires and fire
+OpenFOAM: suppression in buildings, involving combustion, chemical reactions,
+OpenFOAM: heat transfer, liquid sprays and films. It includes tools for meshing
+OpenFOAM: in and around complex geometries (e.g. a vehicle), and for data
+OpenFOAM: processing and visualisation, and more. Almost all computations can be
+OpenFOAM: executed in parallel as standard to take full advantage of today’s
+OpenFOAM: multi-core processors and multi-processor computers.
+OpenFOAM: